"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createBoundedBuffer = createBoundedBuffer;
var arrayUtils_1 = require("./utils/arrayUtils");
var BUFFER_LIMIT = 500;
function createBoundedBuffer() {
    var buffer = [];
    var add = function (callback) {
        var length = buffer.push(callback);
        if (length > BUFFER_LIMIT) {
            buffer.splice(0, 1);
        }
    };
    var remove = function (callback) {
        (0, arrayUtils_1.removeItem)(buffer, callback);
    };
    var drain = function (arg) {
        buffer.forEach(function (callback) { return callback(arg); });
        buffer.length = 0;
    };
    return {
        add: add,
        remove: remove,
        drain: drain,
    };
}
//# sourceMappingURL=boundedBuffer.js.map